@echo off
SetLocal EnableExtensions EnableDelayedExpansion
mode con cols=80 lines=60
 
:: -
Set LogFile=task_monitor.log
::  N 
Set Delay=2
::   
Set Exclude=tasklist.exe svchost.exe avp.exe wmiprvse.exe conhost.exe cmd.exe 
Set Exclude=%Exclude% dllhost.exe SearchProtocolHost.exe SearchFilterHost.exe FlashPlayerUpdateService.exe
Set Exclude=%Exclude% taskeng.exe audiodg.exe GoogleUpdate.exe find.exe wmic.exe taskhost.exe
::        PID
Set Tabulations=3
 
 
Set /A Delay+=1
del "%LogFile%" 2>nul
::    
for %%a in (%Exclude%) do set Exclude.%%a=true
echo Please wait...
echo ----------------------------
call :ProcessListSave
cls
echo Prosess loger started...
echo ----------------
:begin
  ::set /p x=.<nul
  >nul ping 127.1 -n %Delay%
  call :CheckProcesses
goto :begin
 
:ProcessListSave
:: ProcName.PID   
:: ProcPID.N   PID,      
:: PIDPosition.PID  ,    PID,
::       
:: ProcUser.PID  ,     
::Total   - 
  set Total=0
  for /f "skip=2 tokens=1-2 delims=," %%a in ('tasklist /NH /FO:CSV') do (
    if not defined Exclude.%%~a (
      set /a Total+=1
      set ProcName.%%~b=%%~a
      call :GetProcessUserName "%%~a" "%%~b" "ProcUser"
      set ProcUser.%%~b=!ProcUser!
      set ProcPID.!Total!=%%~b
      set PIDPosition.%%~b=!Total!
      call :GetEchoTab "%%~a" %Tabulations% "%%~b   !ProcUser!" "FormatText"
      echo !FormatText!
      rem echo %%~a     %%~b    !ProcUser!
    )
  )
exit /B
 
:CheckProcesses
  call :ClearPIDPositionFlagsArray
  for /f "skip=2 tokens=1-2 delims=," %%a in ('tasklist /NH /FO:CSV') do (
    if not defined Exclude.%%~a (
      rem      PID
      if not defined ProcName.%%~b (call :LogNewProcess "%%~a" "%%~b") else (
        rem  PID          (   :)
        if "!ProcName.%%~b!" neq "%%~a" call :LogNewProcess "%%~a" "%%~b"
      )
      rem       
      set PIDExist.!PIDPosition.%%~b!=true
    )
  )
  ::,       
  for /L %%C in (1,1,%Total%) do if not defined PIDExist.%%C call :LogClosedProcess "!ProcPID.%%C!" "%%C"
exit /b
 
:LogNewProcess
:: %1 -  
:: %2 - PID 
  call :GetProcessUserName "%~1" "%~2" "ProcUser"
  call :GetEchoTab "+ %~1" %Tabulations% "%~2   %ProcUser%  %Time%  %Date%" "FormatText"
  echo %FormatText%
  echo %FormatText%>> "%LogFile%"
  set /a Total+=1
  set ProcName.%~2=%~1
  set ProcUser.%~2=%ProcUser%
  set ProcPID.!Total!=%~2
  set PIDPosition.%~2=!Total!
exit /B
 
:ClearPIDPositionFlagsArray
  for /L %%C in (1,1,%Total%) do set PIDExist.%%C=
exit /B
 
:LogClosedProcess
::%1 - PID 
::%2 -      
  set ProcName=!ProcName.%~1!
  set ProcUser=!ProcUser.%~1!
  call :GetEchoTab "- %ProcName%" %Tabulations% "%~1    %ProcUser%  %Time%  %Date%" "FormatText"
  echo %FormatText%
  echo %FormatText%>> "%LogFile%"
  call :RebuildArrays "%~1" "%~2"
exit /B
 
:RebuildArrays
::   
::%1 - PID 
::%2 -      
  set ProcName.%~1=
  set ProcUser.%~1=
  set PIDPosition.%~1=
  set /A Total-=1
  for /L %%C in (%~2,1,%Total%) do (
    set /A NextPos=%%C + 1
    call set ProcPID.%%C=%%ProcPID.!NextPos!%%
    call set PIDPosition.%%ProcPID.!NextPos!%%=%%C
  )
exit /B
 
:GetProcessUserName
::  ,     
:: %1 -  
:: %2 - PID 
:: %3 - .     
  for /f "tokens=2 delims==; " %%a in ('2^>nul WMIC Process WHERE Handle^="%~2" Call GetOwner ^| find /i "User ="') do (
    set "%~3=%%~a"
  )
Exit /B
 
:GetEchoTab
:: %1 -   
:: %2 -  -     
:: %3 -   
:: %4 - . - ,     
  set "text=%~1"
  set tabs=%~2
  for /L %%C in (7,8,200) do (
    if "!text:~%%C,1!" neq "" (set /A tabs-=1) else (goto ext_EchoTab)
  )
  :ext_EchoTab
  if %tabs%==0 (set "text=%text% ") else (
    for /L %%C in (1,1,%tabs%) do set "text=!text!  ")
  set "%~4=%text%%~3"
exit /B